//////////////////////////////////////////////////////////////////////////////
//
//////////////////////////////////////////////////////////////////////////////
// Copyright(C)2000-2001 by david Raingeard
// cinati@caramail.com or david.raingeard@etu.univ-tours.fr
// For more information please read the readme.txt file
//
//
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __INPUTP_C__
#include <windows.h>
extern BOOL coin1;
extern BOOL coin2;
extern BOOL start1;
extern BOOL start2;
extern BOOL start3;
extern BOOL start4;
extern BOOL player1JoystickRight;
extern BOOL player1JoystickLeft;
extern BOOL player1JoystickDown;
extern BOOL player1JoystickUp;
extern BOOL player1JoystickButton1;
extern BOOL player1JoystickButton2;
extern BOOL player1JoystickButton3;
extern BOOL player2JoystickLeft;
extern BOOL player2JoystickRight;
extern BOOL player2JoystickUp;
extern BOOL player2JoystickDown;
extern BOOL player2JoystickButton1;
extern BOOL player2JoystickButton2;
extern BOOL player2JoystickButton3;

extern BOOL testMode;
extern BOOL continueMode;
extern BOOL demoSounds;
extern BOOL videoFlip;
extern BOOL freezeScreen;
extern BOOL freePlay;
#endif

void inputPort_init(void);
void inputPort_info(HINSTANCE hInstance, HWND hWnd);
void inputPort_configure(HINSTANCE hInstance, HWND hWnd);
void inputPort_change(char *path);
void inputPort_done(void);
void inputPort_update(void);
unsigned inputPort1_readbyte(unsigned address);
unsigned inputPort1_readword(unsigned address);
unsigned inputPort2_readbyte(unsigned address);
unsigned inputPort2_readword(unsigned address);
unsigned inputPort3_readbyte(unsigned address);
unsigned inputPort3_readword(unsigned address);
unsigned inputPort4_readbyte(unsigned address);
unsigned inputPort4_readword(unsigned address);



typedef struct 
{
	BOOL *swapKeys;
	BOOL *coin1;
	BOOL *coin2;
	BOOL *start1;
	BOOL *start2;
	BOOL *start3;
	BOOL *start4;
	BOOL *player1JoystickRight;
	BOOL *player1JoystickLeft;
	BOOL *player1JoystickDown;
	BOOL *player1JoystickUp;
	BOOL *player1JoystickButton1;
	BOOL *player1JoystickButton2;
	BOOL *player1JoystickButton3;
	BOOL *player1JoystickButton4;
	BOOL *player1JoystickButton5;
	BOOL *player1JoystickButton6;
	BOOL *player2JoystickLeft;
	BOOL *player2JoystickRight;
	BOOL *player2JoystickUp;
	BOOL *player2JoystickDown;
	BOOL *player2JoystickButton1;
	BOOL *player2JoystickButton2;
	BOOL *player2JoystickButton3;
	BOOL *player2JoystickButton4;
	BOOL *player2JoystickButton5;
	BOOL *player2JoystickButton6;

	BOOL *testMode;
	BOOL *continueMode;
	BOOL *demoSounds;
	BOOL *videoFlip;
	BOOL *freezeScreen;
	BOOL *freePlay;
	INT8 *numberOfPlayers;
} inputPort_dll_data_gate_struct;

typedef struct
{
	HINSTANCE						dll_hInstance;
	HINSTANCE						win_hInstance;
	HWND							hWnd;
	inputPort_dll_data_gate_struct	*data;
} configure_gate_data;
